*------------convert.prg
*
* Converts prgs with mono "set colo" to both mono & color. for use
* with udf CLR()   (SEE CONVERT.DOC)
*
* public domain
* (no attention paid to coding elegance - just quick functionality)
*
* Written by Michael L. Leventhal, Jr, Chicago (voice: 312-871-1532)
* BBS: Exec Pc, Milwaukee 414 964 5160 or Plantz, Chgo 312 885 2303
*
* Compile with Clipper 87  (Libs: clipper extend)
* (Only need to compile this file, CONVERT.PRG)
*----------------------------------------------
para fname,color_prg

*-------------------------------
*Structure for database : COLOSETS.DBF
*Number of data records : 2
*Date of last update    : 8/24/87
*Field  Field Name  Type       Width
*    1  NAME        Character     20
*    2  W           Character     40
*    3  WPLUS       Character     40
*    4  I           Character     40
*    5  ISTAR       Character     40
*    6  GETIT       Character     40
*
*Structure for database : SHELL.DBF
*Number of data records : 0
*Date of last update    : 8/24/87
*Field  Field Name  Type       Width    Dec
*    1  TEXT        Character    140
*    2  NUMB        Numeric        5
*
*Files:
*       CONVERT.PRG
*       HELP.PRG
*       MAKESCR.PRG (not included in upload)
*       WHAT.PRG
*       CONV.MEM
*       COLOSETS.DBF
*       SHELL.DBF
*       CLR.TXT
*----------------------------------------------
if .f.
  do help
  do what
endif

set key -1 to WHAT
set scoreboard off
set escape on

set decimal to 00
m_count = 0
feeds = chr(10) + chr(10) +chr(13) + spac(9)
syntax = "Syntax:  CONVERT [d:path] <filename> [2d_Parameter]"+;
    feeds + "2d_Paramerter may be anything. If NOT USED, the original"+;
    feeds + "file, unchanged, is given an extension of .B&W and the"+;
    feeds + "file, as converted, the .PRG extension.  If USED, the"+;
    feeds + "original retains the .PRG extension and the file, as"+;
    feeds + "converted is given the .COL extension."

*----------------------------treatments of passed parameters
if .not. EXIST("fname")
      ? syntax
      ?
      retu
endif

if at(".", fname) <> 0
   if lower(subst(fname, at("." , fname) )) <> [.prg]
      ? [Only  .PRG  files are accepted]
      ?
      ? syntax
      ?
      retu
   endif
   if lower(subst(fname, at("." , fname) )) = [.prg] .and. .not. FILE(fname)
      ? [That  .PRG  file not found]
      ?
      ? syntax
      ?
      retu
   endif
else                                 && no ext
   fname = fname + [.prg]
   if .not. FILE(fname)
      ? [That file was not found as a  .PRG  file]
      ?
      ? syntax
      ?
      retu
   endif

endif
*------------------------------eo param treatment

*-------set up routine
rest from conv additive
DO WHILE .T.
   rest screen from topscr
   USE colosets
   loca for upper(Name) = [DEFAULT]
   if .not. found()
      ? ["DEFAULT" not found field "Name" in colosets.dbf !!! ]
      inkey(5)
      retu
   endif
   row = 8
   col = 30
   CLR("BG+/N")
   @ row,col say W
   @ row +2 ,col say Wplus
   @ row +4 ,col say I
   @ row +6 ,col say Istar
   @ row+ 8 ,col say Getit
   *-----------------------------box for color examples
   clr("r/n")
   @ 07,00 to 17,10

   CLR(W)
   @ ROW, 2 SAY [ Color ]
   CLR(WPLUS)
   @ ROW+2, 2 SAY [ Color ]
   CLR(I)
   @ ROW+4, 2 SAY [ Color ]
   CLR(ISTAR)
   @ ROW+6, 2 SAY [ Color ]
   CLR(GETIT)
   @ ROW+8, 2 SAY [ Color ]

   CLR("GR+/N,GR+/R,,,GR+/BG")
   set message to 1
   @ 03,10  prompt "Defaults" message " Use Default Settings Shown Below"
   @ 03,30  prompt "ColorSets" message " Select Color Set from File"
   @ 03,50  prompt "New Set" message " Specify New Set of Color Attributes"
   @ 03,70  prompt "Quit" message " Quit Program  Return to System Prompt"
   CLR("GR+/N")
   menu to Ans
   if lastkey() = 27
      SET CURSOR ON
      close database
      retu
   endif

   do case
      case Ans = 1
         M_W = W
         M_WPLUS = WPLUS
         M_I = I
         M_ISTAR = ISTAR
         M_GETIT = GETIT

        CLR("GR+/N,GR+/R,,,GR+/BG")
        manpik = .t.
        @ row + 12,col clea to row+12,78
        @ row + 12,col say [OK To Use? ] get manpik pict [Y]
        read
        IF MANPIK
           add_func = .f.
           @ row + 12,col clea to row+12,78
           @ row +12, col say [Add CLR() Function to Output File? ];
             get add_func pict [Y]
           read
           CLR("GR+/N")
           EXIT
        else
           LOOP
        endif

      case Ans = 2
         pick = spac(20)
         @ 7,30 CLEAR TO 16,78
         @ 08,55 say [Available Color Sets:]
         USE colosets
         row = 10
         col = 55
         do while .not. eof()
            @ row,col say Name
            row=row+1
            skip
         enddo
         @ 21,30 say [Enter Name of ColorSet: ] get pick PICT [@!]
         read
         go top
         loca for pick = upper(Name)
         if found()
            @ 7,30 CLEAR TO 16,78
            row = 8
            col = 30
            CLR("BG+/N")
            @ row,col say W
            @ row +2 ,col say Wplus
            @ row +4 ,col say I
            @ row +6 ,col say Istar
            @ row+ 8 ,col say Getit

            CLR(W)
            @ ROW, 2 SAY [ Color ]
            CLR(WPLUS)
            @ ROW+2, 2 SAY [ Color ]
            CLR(I)
            @ ROW+4, 2 SAY [ Color ]
            CLR(ISTAR)
            @ ROW+6, 2 SAY [ Color ]
            CLR(GETIT)
            @ ROW+8, 2 SAY [ Color ]

            CLR("GR+/N,GR+/R,,,GR+/BG")
            finalpik = .t.
            @ row +12,COL say [OK to Use? ] get finalpik pict [Y]
            read
            IF FINALPIK
               add_func = .f.
               @ ROW+12,COL CLEA TO ROW+12,78
               @ row +12, col say [Add CLR() Function to Output File? ];
               get add_func pict [Y]
               read
               CLR("GR+/N")
               M_W = W
               M_WPLUS = WPLUS
               M_I = I
               M_ISTAR = ISTAR
               M_GETIT = GETIT
               EXIT
            else
               CLR("GR+/N")
               LOOP
            endif
         else
            @ 21,30 clea to 21,78
            @ 21,30 say [That ColorSet Not Found. Press Key]
            inkey(5)
            LOOP
         endif

      case Ans = 3
         @ 7,30 CLEAR TO 16,78
         M_W = spac(40)
         M_WPLUS = spac(40)
         M_I = spac(40)
         M_ISTAR = spac(40)
         M_GETIT = spac(40)
         row = 8
         col = 30
         @ row,col get M_W pict [@!] VALID TEST(M_W)
         @ row +2 ,col get M_Wplus pict [@!] VALID TEST(M_WPLUS)
         @ row +4 ,col get M_I pict [@!] VALID TEST(M_I)
         @ row +6 ,col get M_Istar pict [@!] VALID TEST(M_ISTAR)
         @ row+ 8 ,col get M_Getit pict [@!] VALID TEST(M_GETIT)
         read
         IF LASTKEY = 27
            LOOP
         ENDIF

         CLR(M_W)
         @ ROW, 2 SAY [ Color ]
         CLR(M_WPLUS)
         @ ROW+2, 2 SAY [ Color ]
         CLR(M_I)
         @ ROW+4, 2 SAY [ Color ]
         CLR(M_ISTAR)
         @ ROW+6, 2 SAY [ Color ]
         CLR(M_GETIT)
         @ ROW+8, 2 SAY [ Color ]

         CLR("GR+/N,GR+/R,,,GR+/BG")
         savit = .t.
         @ row + 10,col say [Save this ColorSet to File? ] get savit pict [Y]
         read
         if savit
            m_name = spac(20)
            @ row + 12, col say [ColorSet Name: ] get m_name pict [@!]
            read
            if len(trim(m_name)) = 0  .or. len(trim(m_w)) = 0
               @ row + 12,col clea to row+12,78
               @ row + 12,col say [NOT SAVED - Press Key]
               inkey(5)
               LOOP
            else
              USE colosets
              appe blank
              replace Name with m_name, W with m_w, Wplus with m_wplus
              repl I with m_i, Istar with m_istar, Getit with m_getit
           endif
        endif

        manpik = .t.
        @ row + 12,col clea to row+12,78
        @ row + 12,col say [OK To Use? ] get manpik pict [Y]
        read
        IF MANPIK
           add_func = .f.
           @ row + 12,col clea to row+12,78
           @ row +12, col say [Add CLR() Function to Output File? ];
             get add_func pict [Y]
           read
           CLR("GR+/N")
           EXIT
        else
           LOOP
        endif

     case Ans = 4
        RETU
   ENDCASE
ENDDO

*------------------------------eo set up
SET CURSOR OFF
CLR("R/N")
CLEA
@ 01,03 TO 5,79
@ 07,03 to 23,79
CLR("GR+/N")
@ 02,05 say [Color Coding Conversion Utility]
if EXIST("color_prg")
    @ 04,05 say [Retaining ] + upper(fname) +[   ] + [Creating ] +;
        upper(substr(fname, 1, at(".",fname))) + [COL]
else
    @ 04,05 say trim(upper(fname)) + [, unchanged, is given .B&W extension;] +;
    [ Converted file,  .PRG]
endif
@ 08,05 say [ZAPPING]
use SHELL
zap

@ 10,05 say [APPENDING]
CLR("b+/n")
@ 08,05 say [ZAPPING]
CLR("GR+/N")
appe from &fname sdf

go top
@ 12,05 say [COUNTING AND REPLACING]
CLR("B+/N")
@ 10,05 say [APPENDING]
CLR("GR+/N")
*------------------------------------------REPL NUMB
graflen = 0
GO TOP
do while .not. eof()
   repl numb with recno() * 10
   graflen = graflen + iif([colo] $ lower(Text),1,0)
   skip
enddo

CLR("B+/N")
@ 12,05 say [COUNTING AND REPLACING]
*-------------------------box for graphic
CLR("GR+/N")
COL = 5
@ 16,col to 18,col+graflen+3

GO TOP
@ 14,05 say [CONVERTING CODE]
CLR("R/N")
last = lastrec()
do while recno() <= last
    do case
       case [set colo to w,i,,,w+] $ lower(Text) .or. [set color to w,i,,,w+]$lower(Text)
          m_count = m_count + 1
          @ 17,col+1+m_count say chr(178)
          @ 14,25 say ltrim(str(m_count/graflen*100)) + [ % Complete]
          M_NUMB = RECNO()
          m_text = Text
          appe blank
          repl Numb with (m_numb * 10) - 5
          repl Text with SUBSTR(m_TEXT,1,RAT(CHR(9),m_TEXT)) +;
          [***] + TRIM( SUBSTR(M_TEXT,RAT(CHR(9),M_TEXT)+1) )
          goto m_numb
          REPL TEXT WITH SUBSTR(TEXT,1,RAT(CHR(9),TEXT)) +;
          [CLR("] + ALLTRIM(M_GETIT) + [")]
          skip
       case [set colo to w+] $ lower(Text) .or. [set color to w+]$lower(Text)
          m_count = m_count + 1
          @ 17,col+1+m_count say chr(178)
          @ 14,25 say ltrim(str(m_count/graflen*100)) + [ % Complete]
          M_NUMB = RECNO()
          m_text = Text
          appe blank
          repl Numb with (m_numb * 10) - 5
          repl Text with SUBSTR(m_TEXT,1,RAT(CHR(9),m_TEXT)) +;
          [***] + TRIM( SUBSTR(M_TEXT,RAT(CHR(9),M_TEXT)+1) )
          goto m_numb
          REPL TEXT WITH SUBSTR(TEXT,1,RAT(CHR(9),TEXT)) +;
          [CLR("] + ALLTRIM(M_WPLUS) + [")]
          skip
       case [set colo to i*] $ lower(Text) .or. [set color to i*]$lower(Text)
          m_count = m_count + 1
          @ 17,col+1+m_count say chr(178)
          @ 14,25 say ltrim(str(m_count/graflen*100)) + [ % Complete]
          M_NUMB = RECNO()
          m_text = Text
          appe blank
          repl Numb with (m_numb * 10) - 5
          repl Text with SUBSTR(m_TEXT,1,RAT(CHR(9),m_TEXT)) +;
          [***] + TRIM( SUBSTR(M_TEXT,RAT(CHR(9),M_TEXT)+1) )
          goto m_numb
          REPL TEXT WITH SUBSTR(TEXT,1,RAT(CHR(9),TEXT)) +;
          [CLR("] + ALLTRIM(M_ISTAR) + [")]
          skip
       case [set colo to w] $ lower(Text) .or. [set color to w]$lower(Text)
          m_count = m_count + 1
          @ 17,col+1+m_count say chr(178)
          @ 14,25 say ltrim(str(m_count/graflen*100)) + [ % Complete]
          M_NUMB = RECNO()
          m_text = Text
          appe blank
          repl Numb with (m_numb * 10) - 5
          repl Text with SUBSTR(m_TEXT,1,RAT(CHR(9),m_TEXT)) +;
          [***] + TRIM( SUBSTR(M_TEXT,RAT(CHR(9),M_TEXT)+1) )
          goto m_numb
          REPL TEXT WITH SUBSTR(TEXT,1,RAT(CHR(9),TEXT)) +;
          [CLR("] + ALLTRIM(M_W) + [")]
          skip
       case [set colo to i] $ lower(Text) .or. [set color to i]$lower(Text)
          m_count = m_count + 1
          @ 17,col+1+m_count say chr(178)
          @ 14,25 say ltrim(str(m_count/graflen*100)) + [ % Complete]
          M_NUMB = RECNO()
          m_text = Text
          appe blank
          repl Numb with (m_numb * 10) - 5
          repl Text with SUBSTR(m_TEXT,1,RAT(CHR(9),m_TEXT)) +;
          [***] + TRIM( SUBSTR(M_TEXT,RAT(CHR(9),M_TEXT)+1) )
          goto m_numb
          REPL TEXT WITH SUBSTR(TEXT,1,RAT(CHR(9),TEXT)) +;
          [CLR("] + ALLTRIM(M_I) + [")]
          skip
       OTHERWISE
          skip
    endcase
enddo
CLR("B+/N")
@ 14,05 say [CONVERTING CODE]
CLR("B/N")
@ 16,col to 18,col+graflen+3

CLR("GR+/N")

if EXIST("color_prg")
   newfile = UPPER(substr(fname, 1, at(".",fname))) + [COL]
else
   newname = substr(fname, 1, at(".",fname)) + [B&W]
   rename &fname to &newname
   newfile = UPPER(substr(fname, 1, at(".",fname))) + [PRG]
endif

@ 20,05 say [INDEXING AND WRITING  ] + newfile + [  TO DISK]
inde on numb to numb

set alternate to &newfile
set alte on
set cons off
*--------------------write  to file
GO TOP
DO WHILE .NOT. EOF()
   ? TRIM(TEXT)
   SKIP
ENDDO
IF add_func
   TYPE CLR.TXT
ENDIF
close alte
set cons on
zap
erase numb.ntx
CLR("B+/N")
@ 20,05 say [INDEXING AND WRITING  ] + newfile + [  TO DISK]
CLR("GR+/N")

@ 22,05 say [CONVERSION COMPLETE.  ] + ltrim(str(m_count)) + [ LINES CONVERTED.]
?
SET CURSOR ON
retu
*------------------eof

FUNCTION EXIST
* Syntax....:  EXIST( <expC> )
* Purpose...:  To test to see if a certain memvar currently exists in memory
* Returns...:  .T. if the memvar exists, .F. if not

Parameter cl_is_var
if type("&cl_is_var") = "U"
   cl_ok = .f.
else
   cl_ok = .t.
endif
return(cl_ok)
*----------------------------eo funct Exist()

FUNCTION CLR
parameter cl_attrib

if ISCOLOR()                      && clipper 86 function
   set colo to &cl_attrib
else
   do case
      case cl_attrib = "GR+/N" .OR. cl_attrib = "gr+/n"
         set colo to w
      case cl_attrib = "GR+/R" .OR. cl_attrib = "gr+/r"
         set colo to I
      case cl_attrib = "GR+/N,GR+/R,,,GR+/BG";
                       .OR. cl_attrib = "gr+/n,gr+/r,,,gr+/bg";
                       .OR. cl_attrib = "GR+/N,GR+/B,,,GR+/BG";
                       .OR. cl_attrib = "gr+/n,gr+/b,,,gr+/bg";
                       .OR. cl_attrib = "GR+/N,W+/R,,,GR+/BG";
                       .OR. cl_attrib = "gr+/n,w+/r,,,gr+/bg";
                       .OR. cl_attrib = "GR+/N,W+/B,,,GR+/BG";
                       .OR. cl_attrib = "gr+/n,w+/b,,,gr+/bg"
         set colo to w,i,,,w+
      case [*] $ cl_attrib
         set colo to w+*
      otherwise
         set colo to w+
   endcase
endif
return []
*-------------------------eo func clr

FUNCTION TEST

parameter cl_flip
private cl_ok
private cl_string,cl_flag
cl_flag = [ ]
cl_string = [N BGXRGW,/+*]

for j = 1 to 40
   if .not. substr(cl_flip,j,1) $ cl_string
      cl_flag = cl_flag + [ ]
   endif
next


if len(cl_flag) = 1
   cl_ok = .t.
else
   SET CURSOR OFF
   cl_ok = .F.
   SAVE SCREEN
   SET SCOREBOARD OFF
   CLR("GR+/N")
   @ 00,00 CLEAR TO 2,79
   @ 00,00 TO 2,79
   CLR("GR+/R")
   @ 01,02 SAY [ Invalid Letter Code or Invalid Symbol Used ]
   CLR("GR+/N")
   @ 01,65 SAY [Press Any Key]
     DO WHILE INKEY() = 0
     ENDDO
   SET SCOREBOARD ON
   RESTORE SCREEN
   SET CURSOR ON
endif

RETURN (cl_ok)

